{% load wagtailcore_tags %}
{% load static %}

<script src="{% static "shared/vendor/chart.js/chart.umd.4.2.0.js" %}"></script>

<div class="py-4">
    <canvas
        class="lg:h-120 lg:w-auto w-full mx-auto"
        id="{{ block.id }}"
    ></canvas>
</div>

<script>
    window.addEventListener(
        "load",
        () => {
            const getRandomInt = (max) => {
                return Math.floor(Math.random() * Math.floor(max));
            }

            const chartType = "{{ value.chart_type }}";
            let colorOrder = getRandomInt(6);
            const colors = [
                "rgba(255, 99, 132, 0.6)",
                "rgba(54, 162, 235, 0.6)",
                "rgba(255, 206, 86, 0.6)",
                "rgba(75, 192, 192, 0.6)",
                "rgba(153, 102, 255, 0.6)",
                "rgba(255, 159, 64, 0.6)",
                "rgba(75, 192, 192, 0.6)",
                "rgba(153, 102, 255, 0.6)",
            ];

            const getColor = () => {
                if (colorOrder === colors.length) {
                    colorOrder = 0;
                }

                return colors[colorOrder++];
            }

            const getDatasets = () => {
                const datasets = {{ value.datasets|safe }};
                let finalDatasets = [];

                for (let i = 0; i < datasets.length; i++) {
                    let tempDataset = {};

                    tempDataset["label"] = datasets[i]["label"];
                    tempDataset["data"] = datasets[i]["data"];

                    if (chartType == "pie" || chartType == "doughnut" || datasets.length == 1) {
                        let backgroundColor = [];

                        for (let j = 0; j < tempDataset["data"].length; j++)
                            backgroundColor.push(getColor());

                        tempDataset["backgroundColor"] = backgroundColor;
                    } else {
                        tempDataset["backgroundColor"] = getColor();
                    }

                    tempDataset["borderColor"] = getColor();
                    tempDataset["borderWidth"] = 1;
                    tempDataset["fill"] = true;
                    tempDataset["tension"] = 0.3;

                    finalDatasets.push(tempDataset);
                }

                return finalDatasets;
            };

            const ctx = document.getElementById("{{ block.id }}").getContext("2d");

            const blockChart = new Chart(
                ctx,
                {
                    type: "{% if value.chart_type != "horizontalBar" %}{{ value.chart_type }}{% else %}bar{% endif %}",
                    data: {
                        labels: {{ value.labels|safe }},
                        datasets: getDatasets(),
                    },
                    options: {
                        {% if value.chart_type == "horizontalBar" %}
                            indexAxis: "y",
                        {% endif %}
                        plugins: {
                            title: {
                                display: true,
                                text: "{{ value.title|escapejs }}",
                            },
                        },
                        scales: {
                            y: {
                                ticks: {
                                    beginAtZero: true,
                                },
                            },
                        }{% if value.hide_points %},
                            elements: {
                                point: {
                                    radius: 0
                                }
                            }
                        {% endif %}
                    }
                }
            );
        }
    );
</script>
